/// <reference types="node" />
import { ExtendableError } from "./errors";
import { IConnection, IConnectEvent, IConnectionManager } from "./types";
export declare class ConnectionNotFoundError extends ExtendableError {
}
declare type Options = {
    connectionsTable?: string;
    subscriptionsTable?: string;
};
declare class DynamoDBConnectionManager implements IConnectionManager {
    private connectionsTable;
    private subscriptionsTable;
    private db;
    constructor({ connectionsTable, subscriptionsTable }?: Options);
    hydrateConnection: (connectionId: string) => Promise<IConnection>;
    registerConnection: ({ connectionId, endpoint }: IConnectEvent) => Promise<IConnection>;
    sendToConnection: (connection: IConnection, payload: string | Buffer) => Promise<void>;
    unregisterConnection: (connection: IConnection) => Promise<void>;
}
export { DynamoDBConnectionManager };
export default DynamoDBConnectionManager;
