import { Sender } from 'xstate';
import { w3cwebsocket } from 'websocket';
import { ClientContext, ClientEvents } from './types';
export declare function connect({ backoff, handleMessage, uri, webSockImpl, }: ClientContext): Promise<w3cwebsocket>;
/**
 * After connection is successful assign returned socket to context
 */
export declare function onConnectSuccess(): import("xstate").AssignAction<{}, import("xstate").EventObject>;
export declare function reconnect(context: ClientContext): Promise<w3cwebsocket>;
export declare const onReconnectSuccess: typeof onConnectSuccess;
export declare function disconnect({ socket }: ClientContext): Promise<void>;
/**
 * Removes socket on successful disconnect
 */
export declare function onDisconnectSuccess(): import("xstate").AssignAction<ClientContext, import("xstate").EventObject>;
/**
 * Processes operations (basically this runs only if client is connected)
 */
export declare function processOperations({ operationProcessor, socket, }: ClientContext): (callback: Sender<ClientEvents>) => () => void;
